#[cfg(test)]
mod tests_logic {
    use crate::visitor_interpreter::*;
    use lox_lexer::lexer::scan_tokens;
    use lox_library;
    use lox_library::Object;
    use crate::expression_tree_builder;
    use crate::interpreter_types::LoxObject;
    use crate::parser::Parser;
    use crate::statement_tree_builder;

    use crate::test::test_helper::test_utils::*;


    #[test]
    fn test_boolean_logic() {
        assert_eq!(parse_and_interpret("false or  false or  false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false or  false or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false or  false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  or  false or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  false or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  or  false or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false and false or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false and false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  and false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  true  and false or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  and false or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  false or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  false or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and false or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  true  or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and true  or  true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and true  or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false and true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and true  or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false and true  or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  and true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  and true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and true  or  false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  and true  or  false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false or  false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false or  false and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false or  false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  or  false and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  false and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  or  false and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false and false and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false and false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  and false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  true  and false and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  and false and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  false or  true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false or  true  and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false or  true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  or  true  and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  true  and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  or  true  and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false and true  and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false and true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  and true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  true  and true  and false ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  and true  and false ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  false or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  false or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and false or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  true  or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and true  or  false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  false and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and false and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  true  and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and true  and false or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  false or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and false or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  true  or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and true  or  true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  false and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and false and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  true  and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and true  and true  or  true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false or  false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false or  false and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false or  false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  or  false and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  false and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  or  false and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false and false and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false and false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  and false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  true  and false and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  and false and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  false or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  false or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and false or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  true  or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  and true  or  true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false or  false and true  and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  or  false and true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and false and true  and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and false and true  and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("false or  true  and true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("true  or  true  and true  and true  ;"), Object::new_bool(true ));
        assert_eq!(parse_and_interpret("false and true  and true  and true  ;"), Object::new_bool(false));
        assert_eq!(parse_and_interpret("true  and true  and true  and true  ;"), Object::new_bool(true ));
                                                                                                                 }
}
